/*-----------------------------------------------------------------------------
 *      GCC sections usage demo (AVR/avr-gcc)
 *-----------------------------------------------------------------------------
 *  Copyright (c) 2011 Oleksandr Redchuk aka ReAl http://real.kiev.ua
 *  Public domain, AS IS.
 *-----------------------------------------------------------------------------
 */

#include <avr/io.h>

#include "sections_demo.h"

static uint8_t print_modules()
{
    const module_decriptor_t *pmodule = MODULE_LIST_START;

    if (pmodule == MODULE_LIST_END) {
        uart_putstr_P(PSTR("No modules registered\n"));
        return 0;
    }

    while (pmodule < MODULE_LIST_END) {
        uart_putchar(pgm_read_byte(&pmodule->code));
        uart_putstr_P(PSTR(" - "));
        uart_putstr_P((const prog_char*)pgm_read_word(&pmodule->description));
        uart_putchar('\n');
        ++pmodule;
    }

    uart_putstr_P(PSTR("? - this help\n"));
    return 1;
}

static const module_decriptor_t *find_module(char ch)
{
    const module_decriptor_t *pmodule = MODULE_LIST_START;

    while (pmodule < MODULE_LIST_END) {
        if (ch == pgm_read_byte(&pmodule->code)) return pmodule;
        ++pmodule;
    }

    return 0;
}

OS_MAIN int main()
{
    uart_putstr_P(PSTR("\n\nHello!\n\n"));

    if (print_modules()) {
        for (;;) {
            char ch = uart_getchar();
            if (ch == '\r' || ch == '\n') continue;
            if (ch == '?') {
                print_modules();
                continue;
            }
            const module_decriptor_t *pmodule = find_module(ch);
            if (pmodule == 0) {
                uart_putstr_P(PSTR("Invalid code, ? for help\n"));
            } else {
                pvfunc_t pfunc = (pvfunc_t)pgm_read_word(&pmodule->func);
                if (pfunc) pfunc();
            }
        }
    }

    for (;;) {}
}


