/*-----------------------------------------------------------------------------
 *      GCC sections usage demo (AVR/avr-gcc)
 *-----------------------------------------------------------------------------
 *  Sections helper macro definition
 *-----------------------------------------------------------------------------
 *  Copyright (c) 2011 Oleksandr Redchuk aka ReAl http://real.kiev.ua
 *  Public domain, AS IS.
 *-----------------------------------------------------------------------------
 */

#ifndef SECTIONS_H
#define SECTIONS_H

// Declare external symbols for section start and end points
#define SECTION_DECL(S) \
    extern unsigned char __ ## S ## _start, __ ## S ## _end;

// Section start and end pointers
#define SECTION_START(S) (& __ ## S ## _start)
#define SECTION_END(S)   (& __ ## S ## _end)

// Section attribute for variable declaration.
#define SECTION(S) __attribute__((__section__( "." #S), used))

#endif  /* SECTIONS_H */

