/*-----------------------------------------------------------------------------
 *      GCC sections usage demo (AVR/avr-gcc)
 *-----------------------------------------------------------------------------
 *  User section .module_list data type declaration and helper macro definition
 *-----------------------------------------------------------------------------
 *  Copyright (c) 2011 Oleksandr Redchuk aka ReAl http://real.kiev.ua
 *  Public domain, AS IS.
 *-----------------------------------------------------------------------------
 */

#ifndef SECTIONS_DEMO_H
#define SECTIONS_DEMO_H

#include <avr/pgmspace.h>
#include "sections.h"

#include "avrgcc_macros.h"
#include "uart.h"

typedef void (*pvfunc_t)();

typedef struct {
    const    prog_char *description;
    pvfunc_t func;
    char     code;
} module_decriptor_t;

SECTION_DECL(module_list)

#define MODULE_LIST_START \
    ((const module_decriptor_t *)SECTION_START(module_list))

#define MODULE_LIST_END   \
    ((const module_decriptor_t *)SECTION_END(module_list))

#define MODULE_DESCRIPTOR(name,func,code) \
    static module_decriptor_t module SECTION(module_list) = \
    { name, func, code }

#define MODULE_DESCRIPTOR_PRIO(name,func,code,prio) \
    static module_decriptor_t module SECTION(module_list. ## prio) = \
    { name, func, code }

#endif  /* SECTIONS_DEMO_H */
