/*-----------------------------------------------------------------------------
 *      .init sections usage demo (AVR/avr-gcc)
 *-----------------------------------------------------------------------------
 *  uart.h -- Minimalistic UART support
 *-----------------------------------------------------------------------------
 *  Copyright (c) 2011 Oleksandr Redchuk aka ReAl http://real.kiev.ua
 *  Public domain, AS IS.
 *-----------------------------------------------------------------------------
 */

#ifndef UART_H
#define UART_H

#include <avr/io.h>
#include <avr/pgmspace.h>

static inline uint8_t uart_rx_available()
{
    return UCSR0A & (1 << RXC0);
}

static inline char uart_getchar()
{
    while (!(UCSR0A & (1 << RXC0))) {}
    return UDR0;
}

void uart_putchar(char ch);
void uart_putstr_P(const prog_char *str);

#endif  /* UART_H */
